<template>
  <div>
    <div class="jumbotron">
      <br/>
      <div v-if="oldHoneyCollection.toString().length > 3">
        <h2>Edytuj zbiór z {{ oldHoneyCollection.collectionDate }}</h2>
        <h6>Zmień tylko te pola, które chcesz. Reszta zostanie nadpisana aktualnymi danymi.</h6>
      </div>
    </div>
    <br/>
    <form
        v-on:submit.prevent="submitForm"
    >
      <div class="form-group">
        <label for="collectionDate">Nowa data zbioru:</label>
        <vue-englishdatepicker
            id="collectionDate"
            placeholder="Data"
            v-model="form.collectionDate"
        />
        <br/>
        Aktualna data zbioru: <strong>{{ oldHoneyCollection.collectionDate }}</strong>
      </div>

      <hr>

      <div class="form-group">
        <label for="honeyType">Nowy rodzaj zebranego miodu:</label>
        <input type="text"
               class="form-control"
               id="honeyType"
               placeholder="Rodzaj miodu"
               v-model="form.honeyType"
        />
        <br/>
        Aktualny rodzaj zebranego miodu: <strong>{{ oldHoneyCollection.honeyType }}</strong>
      </div>

      <hr>

      <div class="form-group">

        <label for="amount">Ilość miodu:</label>
        <vue-slider
            id="amount"
            style="width: 500px"
            :max="50"
            v-model="form.amount"
        />
        <br/>
        Aktualna ilość miodu:
        <strong>{{ oldHoneyCollection.amount }}l.</strong>
      </div>

      <hr>

      <div class="form-group">
        <button class="btn btn-primary">Edytuj</button>
      </div>
    </form>
  </div>

</template>

<script>
import HoneycollectionService from '../../services/honeycollection.service';
import honeycollectionobject from "@/models/honeycollectionobject";
import VueEnglishdatepicker from 'vue-englishdatepicker';

import VueSlider from 'vue-slider-component'
import 'vue-slider-component/theme/antd.css'

export default {
  name: 'EditHoneyCollection',
  components: {
    VueEnglishdatepicker,
    VueSlider
  },
  data() {
    return {
      content: '',
      form: new honeycollectionobject('', '', '', ''),
      wasSubmitted: false,
      oldHoneyCollection: ''
    };
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

    if (!this.currentUser) {
      this.$router.push('/login');
    } else if (this.$route.query.beehiveId && this.$route.query.honeycollectionId) {
      HoneycollectionService.getSpecificHoneyCollectionById(this.$route.query.honeycollectionId).then(
          response => {
            this.oldHoneyCollection = response.data;
          },
          error => {
            this.oldHoneyCollection =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }

  },
  methods: {
    submitForm() {

      if (!this.currentUser) {
        this.$router.push('/login');
      } else {

        if (!this.currentUser) {
          this.$router.push('/login');
        } else if (this.$route.query.beehiveId && this.$route.query.honeycollectionId) {

          this.putOldData()
          this.form.beehiveId = this.$route.query.beehiveId

          HoneycollectionService.editHoneyCollection(this.form, this.$route.query.honeycollectionId).then(
              response => {
                this.content = response.data;
                alert('Zbiór edytowany poprawnie!')
                this.$router.push('/beehive?beehiveid=' + this.$route.query.beehiveId)
              },
              error => {
                this.content =
                    (error.response && error.response.data && error.response.data.message) ||
                    error.message ||
                    error.toString();
              }
          );
        }
      }
    },

    putOldData() {
      if (!this.form.collectionDate)
        this.form.collectionDate = this.oldHoneyCollection.collectionDate;
      if (!this.form.amount)
        this.form.amount = this.oldHoneyCollection.amount;
      if (!this.form.honeyType)
        this.form.honeyType = this.oldHoneyCollection.honeyType;
    }
  }
};
</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}
</style>